#include <stdio.h>
#include <math.h>
#include <vector>
using namespace std;
#include "Cmenu.h"
#include "CBase.h"
#include "CFont.h"

CFont::CFont(CBase *_base)
{
	base = _base;
	//make table for supported chars
	CHAR* ch = &table['0'];
	ch->isChar = true;
	ch->lines.push_back(new CFont::Line(CFont::Point(0.2F,0), CFont::Point(0.8F,0)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.8F, 0), CFont::Point(1, 0.2F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(1, 0.2F), CFont::Point(1, 0.8F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(1, 0.8F), CFont::Point(0.8F, 1)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.8F, 1), CFont::Point(0.2F, 1)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.2F, 1), CFont::Point(0, 0.8F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0, 0.8F), CFont::Point(0, 0.2F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0, 0.2F), CFont::Point(0.2F, 0)));
	ch = &table['1'];
	ch->isChar = true;
	ch->lines.push_back(new CFont::Line(CFont::Point(0.5F, 0), CFont::Point(0.5F, 1)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.5F, 0), CFont::Point(0.2F, 0.3F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.25F, 1), CFont::Point(0.75F, 1)));
	ch = &table['2'];
	ch->isChar = true;
	ch->lines.push_back(new CFont::Line(CFont::Point(0, 0.2F), CFont::Point(0.2F, 0)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.2F, 0), CFont::Point(0.8F, 0)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.8F, 0), CFont::Point(1, 0.2F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(1, 0.2F), CFont::Point(1, 0.5F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(1, 0.5F), CFont::Point(0, 1)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0, 1), CFont::Point(1, 1)));
	ch = &table['3'];
	ch->isChar = true;
	ch->lines.push_back(new CFont::Line(CFont::Point(0, 0.2F), CFont::Point(0.2F, 0)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.2F, 0), CFont::Point(0.8F, 0)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.8F, 0), CFont::Point(1, 0.2F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(1, 0.2F), CFont::Point(1, 0.3F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(1, 0.3F), CFont::Point(0.8F, 0.5F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.8F, 0.5F), CFont::Point(0.3F, 0.5F)));//srodek
	ch->lines.push_back(new CFont::Line(CFont::Point(1, 0.7F), CFont::Point(0.8F, 0.5F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(1, 0.7F), CFont::Point(1, 0.8F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.8F, 1), CFont::Point(1, 0.8F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.2F, 1), CFont::Point(0.8F, 1)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0, 0.8F), CFont::Point(0.2F, 1)));
	ch = &table['4'];
	ch->isChar = true;
	ch->lines.push_back(new CFont::Line(CFont::Point(0.75F, 0), CFont::Point(0.75F, 1)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.75F, 0), CFont::Point(0.25F, 0.6F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.25F, 0.6F), CFont::Point(0.8F, 0.6F)));
	ch = &table['5'];
	ch->isChar = true;
	ch->lines.push_back(new CFont::Line(CFont::Point(0.2F, 0), CFont::Point(1, 0)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.1F, 0.5F), CFont::Point(0.2F, 0)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.8F, 0.5F), CFont::Point(0.1F, 0.5F)));//srodek
	ch->lines.push_back(new CFont::Line(CFont::Point(1, 0.7F), CFont::Point(0.8F, 0.5F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(1, 0.7F), CFont::Point(1, 0.8F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.8F, 1), CFont::Point(1, 0.8F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.2F, 1), CFont::Point(0.8F, 1)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0, 0.8F), CFont::Point(0.2F, 1)));
	ch = &table['6'];
	ch->isChar = true;
	ch->lines.push_back(new CFont::Line(CFont::Point(0, 0.2F), CFont::Point(0.2F, 0)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.2F, 0), CFont::Point(0.8F, 0)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.8F, 0), CFont::Point(1, 0.2F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.8F, 0.5F), CFont::Point(0.2F, 0.5F)));//srodek
	ch->lines.push_back(new CFont::Line(CFont::Point(1, 0.7F), CFont::Point(0.8F, 0.5F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(1, 0.7F), CFont::Point(1, 0.8F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.8F, 1), CFont::Point(1, 0.8F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.2F, 1), CFont::Point(0.8F, 1)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0, 0.8F), CFont::Point(0.2F, 1)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0, 0.3F), CFont::Point(0.2F, 0.5F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0, 0.3F), CFont::Point(0, 0.2F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0, 0.7F), CFont::Point(0.2F, 0.5F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0, 0.7F), CFont::Point(0, 0.8F)));
	ch = &table['7'];
	ch->isChar = true;
	ch->lines.push_back(new CFont::Line(CFont::Point(0.4F, 1), CFont::Point(1, 0)));
	ch->lines.push_back(new CFont::Line(CFont::Point(1,0), CFont::Point(0, 0)));
	ch = &table['8'];
	ch->isChar = true;
	ch->lines.push_back(new CFont::Line(CFont::Point(0, 0.2F), CFont::Point(0.2F, 0)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.2F, 0), CFont::Point(0.8F, 0)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.8F, 0), CFont::Point(1, 0.2F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(1, 0.2F), CFont::Point(1, 0.3F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(1, 0.3F), CFont::Point(0.8F, 0.5F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.8F, 0.5F), CFont::Point(0.2F, 0.5F)));//srodek
	ch->lines.push_back(new CFont::Line(CFont::Point(1, 0.7F), CFont::Point(0.8F, 0.5F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(1, 0.7F), CFont::Point(1, 0.8F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.8F, 1), CFont::Point(1, 0.8F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.2F, 1), CFont::Point(0.8F, 1)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0, 0.8F), CFont::Point(0.2F, 1)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0, 0.3F), CFont::Point(0.2F, 0.5F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0, 0.3F), CFont::Point(0, 0.2F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0, 0.7F), CFont::Point(0.2F, 0.5F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0, 0.7F), CFont::Point(0, 0.8F)));
	ch = &table['9'];
	ch->isChar = true;
	ch->lines.push_back(new CFont::Line(CFont::Point(0, 0.2F), CFont::Point(0.2F, 0)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.2F, 0), CFont::Point(0.8F, 0)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.8F, 0), CFont::Point(1, 0.2F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(1, 0.2F), CFont::Point(1, 0.3F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(1, 0.3F), CFont::Point(0.8F, 0.5F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.8F, 0.5F), CFont::Point(0.2F, 0.5F)));//srodek
	ch->lines.push_back(new CFont::Line(CFont::Point(1, 0.7F), CFont::Point(0.8F, 0.5F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(1, 0.7F), CFont::Point(1, 0.8F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.8F, 1), CFont::Point(1, 0.8F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0.2F, 1), CFont::Point(0.8F, 1)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0, 0.8F), CFont::Point(0.2F, 1)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0, 0.3F), CFont::Point(0.2F, 0.5F)));
	ch->lines.push_back(new CFont::Line(CFont::Point(0, 0.3F), CFont::Point(0, 0.2F)));
}

CFont::~CFont()
{
}

void CFont::RederText(char* string,float x, float y, float width, float height, float fi, float r,float g, float b)
{
	int string_len = strlen(string);
	float cur_x = x;
	//base->DrawLine
	for (int i = 0; i < string_len; i++)
	{
		CHAR* ch = &table[string[i]];
		if (ch->isChar)
		{
			for (int j = 0; j < ch->lines.size(); j++)
			{
				CFont::Line *line = ch->lines.at(j);
				base->DrawLine(cur_x + line->a.x * width, y + line->a.y * height, cur_x + line->b.x * width, y + line->b.y * height, fi, r, g, b);
				
			}
			cur_x += width;
		}
	}
}
