#include "framework.h"
#include "chemistry factory.h"
#include <gl/gl.h>
#include <stdio.h>
#include <math.h>
#include <vector>
using namespace std;
#include "windowsx.h"
#include "CSixTree.h"
#include "CmapGen.h"
#include "Cmenu.h"
#include "CBase.h"
#include "Cconnect.h"

Cconnect::Cconnect(CBase* _base)
{
	base = _base;
	Object* obj = 0;
	Plug* plug = 0;
	obj = new Object;
	obj->type = CSixTree::Field::_sub_type::Belt;
	plug = new Plug;
	plug->type = Plug_type::Output;
	plug->a[0] = Point(0, -1); plug->a[1] = Point(1, 0); plug->a[2] = Point(0, 1); plug->a[3] = Point(-1, 0);
	plug->Joint[0] = 0x1000;
	obj->plugs.push_back(plug);
	plug = new Plug;
	plug->type = Plug_type::Input;
	plug->a[0] = Point(0, 0); plug->a[1] = Point(0, 0); plug->a[2] = Point(0, 0); plug->a[3] = Point(0, 0);
	plug->Joint[0] = 0x0111;
	obj->plugs.push_back(plug);
	Object_Connection_list.push_back(obj);

	obj = new Object;
	obj->type = CSixTree::Field::_sub_type::Under_belt_input;
	plug = new Plug;
	plug->type = Plug_type::Input;
	plug->a[0] = Point(0, 0); plug->a[1] = Point(0, 0); plug->a[2] = Point(0, 0); plug->a[3] = Point(0, 0);
	plug->Joint[0] = 0x0111;
	obj->plugs.push_back(plug);
	Object_Connection_list.push_back(obj);

	obj = new Object;
	obj->type = CSixTree::Field::_sub_type::Under_belt_output;
	plug = new Plug;
	plug->type = Plug_type::Output;
	plug->a[0] = Point(0, -1); plug->a[1] = Point(1, 0); plug->a[2] = Point(0, 1); plug->a[3] = Point(-1, 0);
	plug->Joint[0] = 0x1000;
	obj->plugs.push_back(plug);
	Object_Connection_list.push_back(obj);

	obj = new Object;
	obj->type = CSixTree::Field::_sub_type::Miner;
	plug = new Plug;
	plug->type = Plug_type::Output;
	plug->a[0] = Point(0, -1); plug->a[1] = Point(1, 0); plug->a[2] = Point(0, 1); plug->a[3] = Point(-1, 0);
	plug->Joint[0] = 0x1000;
	obj->plugs.push_back(plug);
	Object_Connection_list.push_back(obj);

	obj = new Object;
	obj->type = CSixTree::Field::_sub_type::Paint_Mixer;
	plug = new Plug;
	plug->type = Plug_type::Output;
	plug->a[0] = Point(0, -1); plug->a[1] = Point(1, 0); plug->a[2] = Point(0, 1); plug->a[3] = Point(-1, 0);
	plug->Joint[0] = 0x1000;
	obj->plugs.push_back(plug);
	plug = new Plug;
	plug->type = Plug_type::Input;
	plug->a[0] = Point(0, 0); plug->a[1] = Point(0, 0); plug->a[2] = Point(0, 0); plug->a[3] = Point(0, 0);
	plug->Joint[0] = 0x0101;
	obj->plugs.push_back(plug);
	Object_Connection_list.push_back(obj);

	obj = new Object;
	obj->type = CSixTree::Field::_sub_type::Painter;
	plug = new Plug;
	plug->type = Plug_type::Output;
	plug->a[0] = Point(0, -1); plug->a[1] = Point(1, 0); plug->a[2] = Point(0, 1); plug->a[3] = Point(-1, 0);
	plug->Joint[0] = 0x1000;
	obj->plugs.push_back(plug);
	plug = new Plug;
	plug->type = Plug_type::Input;
	plug->a[0] = Point(0, 0); plug->a[1] = Point(0, 0); plug->a[2] = Point(0, 0); plug->a[3] = Point(0, 0);
	plug->Joint[0] = 0x0011;
	obj->plugs.push_back(plug);
	Object_Connection_list.push_back(obj);

	obj = new Object;
	obj->type = CSixTree::Field::_sub_type::Spliter;

	plug = new Plug;
	plug->type = Plug_type::Output;//top
	plug->a[0] = Point(0, -1); plug->a[1] = Point(1, 0); plug->a[2] = Point(0, 1); plug->a[3] = Point(-1, 0);
	plug->Joint[0] = 0x1000;
	obj->plugs.push_back(plug);

	plug = new Plug;
	plug->type = Plug_type::Output;//right
	plug->a[0] = Point(1, 0); plug->a[1] = Point(0, 1); plug->a[2] = Point(-1, 0); plug->a[3] = Point(0, -1);
	plug->Joint[0] = 0x0100;
	obj->plugs.push_back(plug);

	plug = new Plug;
	plug->type = Plug_type::Output;//left
	plug->a[0] = Point(-1, 0); plug->a[1] = Point(0, -1); plug->a[2] = Point(1, 0); plug->a[3] = Point(0, 1);
	plug->Joint[0] = 0x0001;
	obj->plugs.push_back(plug);

	plug = new Plug;
	plug->type = Plug_type::Input;
	plug->a[0] = Point(0, 0); plug->a[1] = Point(0, 0); plug->a[2] = Point(0, 0); plug->a[3] = Point(0, 0);
	plug->Joint[0] = 0x0010;
	obj->plugs.push_back(plug);
	Object_Connection_list.push_back(obj);
	//                Y
	// X  -1 0 1 2 3  
	//     X|X|X|X|X -1
	//     X|Z|O|O|X  0
	//     X|O|O|O|X  1
	//     X|O|O|O|X  2
	//     X|X|X|X|X  3


	obj = new Object;
	obj->type = CSixTree::Field::_sub_type::Output;
	plug = new Plug;
	plug->type = Plug_type::Input;//top-left corner
	plug->a[0] = Point(0, 0); plug->a[1] = Point(0, 0); plug->a[2] = Point(0, 0); plug->a[3] = Point(0, 0);
	plug->Joint[0] = 0x1001;
	obj->plugs.push_back(plug);
	plug = new Plug;
	plug->type = Plug_type::Input;//top
	plug->a[0] = Point(1, 0); plug->a[1] = Point(2, 1); plug->a[2] = Point(1, 2); plug->a[3] = Point(0, 1);
	plug->Joint[0] = 0x1000;
	obj->plugs.push_back(plug);
	plug = new Plug;
	plug->type = Plug_type::Input;//top-right corner
	plug->a[0] = Point(2, 0); plug->a[1] = Point(2, 2); plug->a[2] = Point(0, 2); plug->a[3] = Point(0, 0);
	plug->Joint[0] = 0x1100;
	obj->plugs.push_back(plug);

	plug = new Plug;
	plug->type = Plug_type::Input;//right
	plug->a[0] = Point(2, 1); plug->a[1] = Point(1, 2); plug->a[2] = Point(0, 1); plug->a[3] = Point(1, 0);
	plug->Joint[0] = 0x0100;
	obj->plugs.push_back(plug);
	plug = new Plug;
	plug->type = Plug_type::Input;//right-bottom corner
	plug->a[0] = Point(2, 2); plug->a[1] = Point(1, 2); plug->a[2] = Point(0, 1); plug->a[3] = Point(1, 0);
	plug->Joint[0] = 0x0110;
	obj->plugs.push_back(plug);
	plug = new Plug;
	plug->type = Plug_type::Input;//bottom
	plug->a[0] = Point(1, 2); plug->a[1] = Point(0, 1); plug->a[2] = Point(1, 0); plug->a[3] = Point(2, 1);
	plug->Joint[0] = 0x0010;
	obj->plugs.push_back(plug);

	plug = new Plug;
	plug->type = Plug_type::Input;//bottom-left corner
	plug->a[0] = Point(0, 2); plug->a[1] = Point(0, 0); plug->a[2] = Point(2, 0); plug->a[3] = Point(2, 2);
	plug->Joint[0] = 0x0011;
	obj->plugs.push_back(plug);
	plug = new Plug;
	plug->type = Plug_type::Input;//left
	plug->a[0] = Point(0, 1); plug->a[1] = Point(1, 0); plug->a[2] = Point(2, 1); plug->a[3] = Point(1, 2);
	plug->Joint[0] = 0x0001;
	obj->plugs.push_back(plug);
	Object_Connection_list.push_back(obj);
	//build BBoxes
	for (size_t i = 0; i < Object_Connection_list.size(); i++)
	{
		Object* obj = Object_Connection_list.at(i);
		Point min, max;
		for (size_t j = 0; j < obj->plugs.size(); j++)
		{
			Plug* plug = obj->plugs.at(j);
			for (int c = 0; c < 4; c++)
			{
				min.x = min(plug->a->x, min.x);
				min.y = min(plug->a->y, min.y);
				max.x = max(plug->a->x, max.x);
				max.y = max(plug->a->y, max.y);
			}
			unsigned int last = 0;
			if (plug->type == Plug_type::Input)
				for (int c = 0; c < 4; c++)
				{
					if (last == 0)
						last = plug->Joint[c];
					else
					{
						last = MoveTrueTableRight(last);
						plug->Joint[c] = last;
					}

					plug->Joint[c] = FlipTrueTable(plug->Joint[c]);
				}
			if (plug->type == Plug_type::Output)
				for (int c = 0; c < 4; c++)
				{
					if (last == 0)
						last = plug->Joint[c];
					else
					{
						last = MoveTrueTableRight(last);
						plug->Joint[c] = last;
					}

					plug->Joint[c] = plug->Joint[c];
				}
		}
		obj->Base_pos = min;
		obj->size = Point(max.x - min.x, max.y - min.y);
	}
	null.type = CSixTree::Field::_sub_type::None;
	ColorTable = new CSixTree::Field::color[12];
	ColorTable[0] = CSixTree::Field::color(255, 244, 2);  //YELLOW
	ColorTable[1] = CSixTree::Field::color(71, 175, 64);  //LEAF
	ColorTable[2] = CSixTree::Field::color(1, 147, 64);   //GREEN
	ColorTable[3] = CSixTree::Field::color(0, 147, 141);  //BLUE GREEN
	ColorTable[4] = CSixTree::Field::color(0, 101, 169);  //BLUE
	ColorTable[5] = CSixTree::Field::color(41, 22, 111);  //ULTRA
	ColorTable[6] = CSixTree::Field::color(70, 27, 106);  //VIOLET
	ColorTable[7] = CSixTree::Field::color(129, 26, 97);  //RED VIOLET
	ColorTable[8] = CSixTree::Field::color(219, 38, 29);  //RED
	ColorTable[9] = CSixTree::Field::color(228, 103, 19); //RED ORANGE
	ColorTable[10] = CSixTree::Field::color(230, 120, 25);//ORANGE
	ColorTable[11] = CSixTree::Field::color(241, 174, 23);//DEEP YELLOW
}

Cconnect::~Cconnect()
{
}

unsigned int Cconnect::FlipTrueTable(unsigned int val)
{
	unsigned int a = ((val & 0x1000) > 0) ? 0x0010 : 0;
	unsigned int b = ((val & 0x0100) > 0) ? 0x0001 : 0;
	unsigned int c = ((val & 0x0010) > 0) ? 0x1000 : 0;
	unsigned int d = ((val & 0x0001) > 0) ? 0x0100 : 0;
	return a | b | c | d;
}

unsigned int Cconnect::MoveTrueTableRight(unsigned int val)
{
	unsigned int a = ((val & 0x1000) > 0) ? 0x0100 : 0;
	unsigned int b = ((val & 0x0100) > 0) ? 0x0010 : 0;
	unsigned int c = ((val & 0x0010) > 0) ? 0x0001 : 0;
	unsigned int d = ((val & 0x0001) > 0) ? 0x1000 : 0;
	return a | b | c | d;
}

void Cconnect::ConnectObject(CSixTree::Field* field)
{
	if ((field->sub_type == CSixTree::Field::_sub_type::Under_belt_input) || (field->sub_type == CSixTree::Field::_sub_type::Under_belt_output))
	{
		vector<CSixTree::Field*>* temp = base->tree->node->GetArea(field->posx, field->posy, 8, 8);
		for (int i = 0; i < temp->size(); i++)
		{
			CSixTree::Field* objekt = temp->at(i);
			if ((objekt != field) && (field->sub_type != objekt->sub_type) && (field->kierunek == objekt->kierunek))
			{
				if (objekt->sub_type == CSixTree::Field::_sub_type::Under_belt_input)
				{
					bool jest = false;
					if ((field->kierunek == CSixTree::Field::_kierunek::up) && (objekt->posx == field->posx) && (objekt->posy > field->posy) && (objekt->posy < field->posy + 6))
						jest = true;
					if ((field->kierunek == CSixTree::Field::_kierunek::right) && (objekt->posy == field->posy) && (objekt->posx < field->posx) && (objekt->posx > field->posx - 6))
						jest = true;
					if ((field->kierunek == CSixTree::Field::_kierunek::bottom) && (objekt->posx == field->posx) && (objekt->posy < field->posy) && (objekt->posy > field->posy - 6))
						jest = true;
					if ((field->kierunek == CSixTree::Field::_kierunek::left) && (objekt->posy == field->posy) && (objekt->posx > field->posx) && (objekt->posx < field->posx + 6))
						jest = true;
					if (jest)
					{
						float dest = 8;
						bool istnieje = false;
						for (int d = 0; d < objekt->belt_next.size(); d++)
						{
							if (objekt->belt_next.at(d) == field)
								istnieje = true;

							float	dest_new  = (objekt->belt_next.at(d)->posx - objekt->posx) * (objekt->belt_next.at(d)->posx - objekt->posx);
									dest_new += (objekt->belt_next.at(d)->posy - objekt->posy) * (objekt->belt_next.at(d)->posy - objekt->posy);
									dest_new  = sqrt(dest_new);
									dest = min(dest, dest_new);
						}
						if (!istnieje)
						{
							float	dest_new  = (objekt->posx - field->posx) * (objekt->posx - field->posx);
									dest_new += (objekt->posy - field->posy) * (objekt->posy - field->posy);
									dest_new  = sqrt(dest_new);
							if (dest_new < dest)
							{
								objekt->belt_next.clear();
								objekt->belt_next.push_back(field);
							}
						}
					}
				}
				if ((objekt->sub_type == CSixTree::Field::_sub_type::Under_belt_output) && (field->sub_type == CSixTree::Field::_sub_type::Under_belt_input))
				{
					bool jest = false;
					if ((field->kierunek == CSixTree::Field::_kierunek::up) && (objekt->posx == field->posx) && (objekt->posy < field->posy) && (objekt->posy > field->posy - 6))
						jest = true;
					if ((field->kierunek == CSixTree::Field::_kierunek::right) && (objekt->posy == field->posy) && (objekt->posx > field->posx) && (objekt->posx < field->posx + 6))
						jest = true;
					if ((field->kierunek == CSixTree::Field::_kierunek::bottom) && (objekt->posx == field->posx) && (objekt->posy > field->posy) && (objekt->posy < field->posy + 6))
						jest = true;
					if ((field->kierunek == CSixTree::Field::_kierunek::left) && (objekt->posy == field->posy) && (objekt->posx < field->posx) && (objekt->posx > field->posx - 6))
						jest = true;
					if (jest)
					{
						float dest = 6;
						bool istnieje = false;
						for (int d = 0; d < field->belt_next.size(); d++)
						{
							if (field->belt_next.at(d) == objekt)
								istnieje = true;
							float	dest_new  = (objekt->belt_next.at(d)->posx - field->posx) * (objekt->belt_next.at(d)->posx - field->posx);
									dest_new += (objekt->belt_next.at(d)->posy - field->posy) * (objekt->belt_next.at(d)->posy - field->posy);
									dest_new  = sqrt(dest_new);
									dest	  = min(dest, dest_new);
						}
						if (!istnieje)
						{
							float	dest_new = (objekt->posx - field->posx) * (objekt->posx - field->posx);
							dest_new += (objekt->posy - field->posy) * (objekt->posy - field->posy);
							dest_new = sqrt(dest_new);
							if (dest_new < dest)
							{
								field->belt_next.clear();
								field->belt_next.push_back(objekt);
							}
							
						}
					}
				}
			}
		}
	}
	//find for field places to connect
	vector<CSixTree::Field*>* temp = base->tree->node->GetArea(field->posx - 1, field->posy - 1, 3, 3);
	Object* obj_base = GetObjectByType(field->sub_type);
	for (int i = 0; i < temp->size(); i++)
	{
		CSixTree::Field* objekt = temp->at(i);
		if (objekt != field)
		{
			if ((field->sub_type == CSixTree::Field::_sub_type::Miner) && (field->posx == objekt->posx) && (field->posy == objekt->posy))
			{
				if (objekt->type == CSixTree::Field::_type::Resource)
					field->miner = objekt;
			}
			Object* obj_target = GetObjectByType(objekt->sub_type);
			for (int a = 0; a < obj_base->plugs.size(); a++)
			{
				Cconnect::Plug* plug_base = obj_base->plugs.at(a);
				for (int b = 0; b < obj_target->plugs.size(); b++)
				{
					Cconnect::Plug* plug_target = obj_target->plugs.at(b);
					if (plug_base->type != plug_target->type)
					{
						Point p_bb = plug_base->a[field->kierunek];
						Point p_tt = plug_target->a[objekt->kierunek];
						p_bb.x += field->posx;
						p_bb.y += field->posy;
						p_tt.x += objekt->posx;
						p_tt.y += objekt->posy;
						if ((p_bb.x == p_tt.x) && (p_bb.y == p_tt.y) && ((plug_base->Joint[field->kierunek] & plug_target->Joint[objekt->kierunek]) > 0))
							if (plug_base->type != Cconnect::Plug_type::Input)
							{
								bool istnieje = false;
								for (int d = 0; d < field->belt_next.size(); d++)
								{
									if (field->belt_next.at(d) == objekt)
										istnieje = true;
								}
								if (!istnieje)
									field->belt_next.push_back(objekt);
							}
							else
							{
								bool istnieje = false;
								for (int d = 0; d < objekt->belt_next.size(); d++)
								{
									if (objekt->belt_next.at(d) == field)
										istnieje = true;
								}
								if (!istnieje)
									objekt->belt_next.push_back(field);
							}

					}
				}
			}
		}
	}
}

void Cconnect::RemoveObject(CSixTree::Field* field)
{
	vector<CSixTree::Field*> temporary;
	if (field->sub_type == CSixTree::Field::_sub_type::Under_belt_output)
	{

		vector<CSixTree::Field*>* temp = base->tree->node->GetArea(field->posx, field->posy, 8, 8);
		for (int i = 0; i < temp->size(); i++)
		{
			CSixTree::Field* objekt = temp->at(i);
			for (int j = 0; j < objekt->belt_next.size(); j++)
			{
				if (objekt->belt_next.at(j) == field)
				{
					//need fix that object connection
					temporary.push_back(objekt);
				}
			}
		}
	}
	int j = 0;
	int n = 0;
	while (j < field->belt_next.size())
	{
		while (n < field->belt_next.at(j)->Targeted.size())
		{
			if (field->belt_next.at(j)->Targeted.at(n) == field)
			{
				if (field->belt_next.at(j)->Targeted.size() == 1)
					field->belt_next.at(j)->Targeted.clear();
				else
					field->belt_next.at(j)->Targeted.erase(field->belt_next.at(j)->Targeted.begin() + n);
			}
			n++;
		}
		j++;
	}
	field->belt_next.clear();
	vector<CSixTree::Field*>* temp = base->tree->node->GetArea(field->posx - 1, field->posy - 1, 3, 3);
	for (int i = 0; i < temp->size(); i++)
	{
		CSixTree::Field* objekt = temp->at(i);
		if (objekt != field)
		{
			j = 0;
			while (j < objekt->belt_next.size())
			{
				if (objekt->belt_next.at(j) == field)
				{
					if (objekt->belt_next.size() == 1)
						objekt->belt_next.clear();
					else
					{
						objekt->belt_next.erase(objekt->belt_next.begin() + j);
						if (objekt->belt_next_pos >= objekt->belt_next.size())
							objekt->belt_next_pos = 0;
					}
				}
				else
					j++;
			}
		}
	}
	base->tree->node->RemoveField(field);
	if (temporary.size() > 0)
	{
		DisconnectObject(temporary.at(0));
		ConnectObject(temporary.at(0));
	}
}

void Cconnect::DisconnectObject(CSixTree::Field* field)
{
	int j = 0;
	int n = 0;
	while (j < field->belt_next.size())
	{
		while (n < field->belt_next.at(j)->Targeted.size())
		{
			if (field->belt_next.at(j)->Targeted.at(n) == field)
			{
				if (field->belt_next.at(j)->Targeted.size() == 1)
					field->belt_next.at(j)->Targeted.clear();
				else
					field->belt_next.at(j)->Targeted.erase(field->belt_next.at(j)->Targeted.begin() + n);
			}
			n++;
		}
		j++;
	}
	field->belt_next.clear();
	vector<CSixTree::Field*>* temp = base->tree->node->GetArea(field->posx - 1, field->posy - 1, 3, 3);
	for (int i = 0; i < temp->size(); i++)
	{
		CSixTree::Field* objekt = temp->at(i);
		if (objekt != field)
		{
			j = 0;
			while (j < objekt->belt_next.size())
			{
				if (objekt->belt_next.at(j) == field)
				{
					if (objekt->belt_next.size() == 1)
						objekt->belt_next.clear();
					else
					{
						objekt->belt_next.erase(objekt->belt_next.begin() + j);
						if (objekt->belt_next_pos >= objekt->belt_next.size())
							objekt->belt_next_pos = 0;
					}
				}
				else
					j++;
			}
		}
	}
	field->belt_next.clear();
	field->Targeted.clear();
	field->belt_next_pos = 0;
}

Cconnect::Object* Cconnect::GetObjectByType(CSixTree::Field::_sub_type type)
{
	for (size_t i = 0; i < Object_Connection_list.size(); i++)
	{
		Object* obj = Object_Connection_list.at(i);
		if (obj->type == type)
			return obj;
	}
	return &null;
}
