#pragma once
#pragma warning(disable : 26812)
class Cconnect
{
    struct Point { 
        int x, y; 
        Point() 
        {
            x = 0;
            y = 0;
        };
        Point(int _x, int _y)
        {
            x = _x;
            y = _y;
        };
    };
    enum Plug_type {
        Blocked = 0,
        Input = 1,
        Output = 2
    };
    struct Plug { 
        Point a[4];//points for each direction
        Plug_type type = Plug_type::Input;
        unsigned int Joint[4];//0x1111
    };
    struct Object {
        vector<Plug*> plugs;
        CSixTree::Field::_sub_type type;
        Point Base_pos;
        Point size;
    };
    vector< Object*> Object_Connection_list;
    unsigned int FlipTrueTable(unsigned int val);
    unsigned int MoveTrueTableRight(unsigned int val);
    CBase* base;
    Object null;

    
public:
    Cconnect(CBase* _base);
    ~Cconnect();

    void ConnectObject(CSixTree::Field* field);
    void RemoveObject(CSixTree::Field* field);
    void DisconnectObject(CSixTree::Field* field);
    Object* GetObjectByType(CSixTree::Field::_sub_type type);
    CSixTree::Field::color* ColorTable;
};

